#import <Foundation/Foundation.h>

// インタフェースの宣言
@interface Person : NSObject {
  NSString *name;
}

- (void)sayHello;

@property (nonatomic, copy) NSString *name;

@end

// 実装
@implementation Person

@synthesize name;

- (void)sayHello {
  NSLog(@"Hi, I'm %@", self.name);
}

- (void)dealloc {
  self.name = nil;
  [super dealloc];
}

@end

int main(int argc, const char *argv[]) {
  NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
  Person *mac = [[[Person alloc] init] autorelease];
  mac.name = @"Mac";
  [mac sayHello];
  [pool release];
  return 0;
}
